import numpy as np
import pandas as pd
from influxdb import DataFrameClient
from statsmodels.tsa.statespace.sarimax import SARIMAX

df = pd.DataFrame()
df = pd.read_csv("InputData.csv", parse_dates=[0])
df.rename(columns={'0': 'Data', '1': 'Value'}, inplace=True)
df = df.set_index("Data")

client = DataFrameClient(host = 'influxdb', port = 8086)
client.create_database("PollutionWorks_New")
client.switch_database("PollutionWorks_New")
client.write_points(df, 'Pollution_New')

x = client.query("SELECT * FROM Pollution_New")

df = pd.DataFrame(x['Pollution_New'])

df_work = df.rename(columns={' Value': 'Value'})

print(df_work)

df_train = df_work.head(300)
df_test = df_work.tail(130)

model = SARIMAX(df_train, order=(11, 0, 11))
modelfit = model.fit()

start = len(df_work)
end = len(df_work) + len(df_test) - 1

predict = modelfit.predict(start, end)

times = df_work.reset_index()['index']

a = df_train
b = pd.DataFrame(predict)
b = b.rename(columns={'predicted_mean': 'Value'})
c = [a, b]
c = pd.concat(c)

c = c.reset_index()
c = pd.DataFrame(c['Value'])
c["times"] = times
c = c.set_index('times')
print(c)

client.create_database('PollutionWorks_NewII')
client.switch_database('PollutionWorks_NewII')
client.write_points(c, measurement="pollution_predict_test")


i = df_test.reset_index()['index']
b.index = i
checking = np.square(np.subtract(df_test, b)).mean()
print(checking)